/* Copyright (c) 2017 MJ Rutter 
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street,
 * Fifth Floor, Boston, MA  02110-1301, USA.
 */ 

/* print a string Base64 encoded
 * MJR 5/17
 */

#include<stdio.h>

/* If line_len not zero, print newlines to break lines into this length */

void B64p(FILE* fout, unsigned char* in, int len, int line_len){
  char code[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";
  int i,j;
  int tmp,idx;
  char out[4];

  i=0;
  j=0;
  while(i<len){
    tmp=in[i++]<<8;
    if (i<len) tmp+=in[i++];
    tmp=tmp<<8;
    if (i<len) tmp+=in[i++];

    idx=(tmp&0xfc0000)>>18;
    out[0]=code[idx];

    idx=(tmp&0x3f000)>>12;
    out[1]=code[idx];
    
    idx=(tmp&0xfc0)>>6;
    out[2]=code[idx];

    idx=(tmp&0x3f);
    out[3]=code[idx];

    fwrite(out,4,1,fout);
    j+=4;
    if(line_len&&(j>=line_len)){
      fprintf(fout,"\n");
      j=0;
    }
  }
}
