/* Rotate a bitmap from portrait to landscape:
 *  y -> x
 *  x -> -y
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "bmp2eps.h"

void rotate_image(struct bitmap *image){
  int i,j,k,bytes_per_pixel,debug;
  unsigned char *new_data,*ptr1,*ptr2;
  int new_width,new_height,scanlen,new_scanlen,tmp;

  debug=image->flags&DEBUG_MASK;

  fprintf(stderr,"Rotate called\n");
  
  new_width=image->height;
  new_height=image->width;

  scanlen=(image->width*image->depth+7)/8;
  new_scanlen=(new_width*image->depth+7)/8;

  bytes_per_pixel=image->depth/8;
  
  if ((image->depth&7)!=0){
    if (debug) fprintf(stderr,"Increasing depth before rotation\n");
    tmp=image->pal_len;
    if (image->colour==GREY) image->pal_len=1<<image->depth;
    decompact(image);
    rotate_image(image);
    compact(image);
    image->pal_len=tmp;
    return;
  }
  
  new_data=malloc(new_height*new_scanlen);
  if (!new_data){
    fprintf(stderr,"Malloc error in rotate\n");
    exit(1);
  }

  if ((image->depth&7)==0){
    for(i=0;i<new_height;i++){
      ptr1=new_data+i*new_scanlen;
      for(j=0;j<new_width;j++){
	ptr2=image->data+j*scanlen+(image->width-i-1)*bytes_per_pixel;
	for(k=0;k<bytes_per_pixel;k++)
	  *(ptr1++)=*(ptr2++);
      }
    }
  }

  free(image->data);
  image->data=new_data;
  image->height=new_height;
  image->width=new_width;
  
}
